//
//  LuaProxy.m
//  lua-objc
//
//  Created by kiss on Thu Feb 22 2001.
//  Copyright (c) 2000 __CompanyName__. All rights reserved.
//

#import "LuaProxy.h"

#include "lua.h"
#include <objc/objc-class.h>
#include "gluelib.h"

@interface LuaMethodSignature : NSObject{}
@end

@implementation LuaMethodSignature

-(id)selW0Args { return nil; }
-(id)selW1Args:(id)a1 { return nil; }
-(id)selW2Args:(id)a1 :(id)a2 { return nil; }
-(id)selW3Args:(id)a1 :(id)a2 :(id)a3 { return nil; }
-(id)selW4Args:(id)a1 :(id)a2 :(id)a3 :(id)a4 { return nil; }
-(id)selW5Args:(id)a1 :(id)a2 :(id)a3 :(id)a4 :(id)a5 { return nil; }
-(id)selW6Args:(id)a1 :(id)a2 :(id)a3 :(id)a4 :(id)a5 :(id)a6 { return nil; }
-(id)selW7Args:(id)a1 :(id)a2 :(id)a3 :(id)a4 :(id)a5 :(id)a6 :(id)a7 { return nil; }
-(id)selW8Args:(id)a1 :(id)a2 :(id)a3 :(id)a4 :(id)a5 :(id)a6 :(id)a7 :(id)a8 { return nil; }
-(id)selW9Args:(id)a1 :(id)a2 :(id)a3 :(id)a4 :(id)a5 :(id)a6 :(id)a7 :(id)a8 :(id)a9{ return nil; }
-(id)selW10Args:(id)a1 :(id)a2 :(id)a3 :(id)a4 :(id)a5 :(id)a6 :(id)a7 :(id)a8 :(id)a9 :(id)a10 { return nil; }
-(id)selW11Args:(id)a1 :(id)a2 :(id)a3 :(id)a4 :(id)a5 :(id)a6 :(id)a7 :(id)a8 :(id)a9 :(id)a10 :(id)a11 { return nil; }
-(id)selW12Args:(id)a1 :(id)a2 :(id)a3 :(id)a4 :(id)a5 :(id)a6 :(id)a7 :(id)a8 :(id)a9 :(id)a10 :(id)a11 :(id)a12 { return nil; }

static LuaMethodSignature *lms = nil;

static NSMethodSignature* luaMethodSignatureForSelectorCount(unsigned count)
{
    if (lms == nil) lms = [[LuaMethodSignature alloc] init];
    switch (count)
    {
        case 0: return [lms methodSignatureForSelector:@selector(selW0Args)];
        case 1: return [lms methodSignatureForSelector:@selector(selW1Args)];
        case 2: return [lms methodSignatureForSelector:@selector(selW2Args)];
        case 3: return [lms methodSignatureForSelector:@selector(selW3Args)];
        case 4: return [lms methodSignatureForSelector:@selector(selW4Args)];
        case 5: return [lms methodSignatureForSelector:@selector(selW5Args)];
        case 6: return [lms methodSignatureForSelector:@selector(selW6Args)];
        case 7: return [lms methodSignatureForSelector:@selector(selW7Args)];
        case 8: return [lms methodSignatureForSelector:@selector(selW8Args)];
        case 9: return [lms methodSignatureForSelector:@selector(selW9Args)];
        case 10: return [lms methodSignatureForSelector:@selector(selW10Args)];
        case 11: return [lms methodSignatureForSelector:@selector(selW11Args)];
        case 12: return [lms methodSignatureForSelector:@selector(selW12Args)];
        default: break;
    }
    return nil;
}

static NSMethodSignature* luaMethodSignatureForSelectorName(const char *aName)
{
    unsigned n = 0;
    while (*aName != 0)
    {
        if ((*aName == ':') || (*aName == '_')) n++;
        aName++;
    }
    return luaMethodSignatureForSelectorCount(n);
}

@end


void invokeLuaFunctionOnTopOfStack(LuaState *state, NSInvocation *anInvocation)
{
    NSMethodSignature *signature = [anInvocation methodSignature];
    int args = [signature numberOfArguments];
    int i;
    const char *type;
    lua_State *L = [state lua_State];
    id *objectPtr;
    double number;
    char charBuffer;
    short shortBuffer;
    int intBuffer;
    long longBuffer;
    float floatBuffer;
    double doubleBuffer;

    for (i=2;i<args;i++)
    {
        type = [signature getArgumentTypeAtIndex:i];
        switch (type[strlen(type)-1])
        {
            case _C_ID:
                objectPtr = (id *)lua_newuserdata(L, sizeof(id));
                lua_settag(L, state->idTag);
                [anInvocation getArgument:objectPtr atIndex:i];
                NSLog(@"converting to ID: %@", *objectPtr);
                break;
            case _C_UCHR:
                [anInvocation getArgument:&charBuffer atIndex:i];
                number = (unsigned char)charBuffer;
                goto returnValue;
            case _C_CHR:
                [anInvocation getArgument:&charBuffer atIndex:i];
                number = (char)charBuffer;
                goto returnValue;
            case _C_SHT:
                [anInvocation getArgument:&shortBuffer atIndex:i];
                number = (short)shortBuffer;
                goto returnValue;
            case _C_USHT:
                [anInvocation getArgument:&shortBuffer atIndex:i];
                number = (unsigned short)shortBuffer;
                goto returnValue;
            case _C_INT:
                [anInvocation getArgument:&intBuffer atIndex:i];
                number = (int)intBuffer;
                goto returnValue;
            case _C_UINT:
                [anInvocation getArgument:&intBuffer atIndex:i];
                number = (unsigned int)intBuffer;
                goto returnValue;
            case _C_LNG:
                [anInvocation getArgument:&longBuffer atIndex:i];
                number = (long)longBuffer;
                goto returnValue;
            case _C_ULNG:
                [anInvocation getArgument:&longBuffer atIndex:i];
                number = (unsigned long)longBuffer;
                goto returnValue;
            case _C_FLT:
                [anInvocation getArgument:&floatBuffer atIndex:i];
                number = (float)floatBuffer;
                goto returnValue;
            case _C_DBL:
                [anInvocation getArgument:&doubleBuffer atIndex:i];
                number = (double)doubleBuffer;
            returnValue:
                NSLog(@"arg %d (number) = %f", i, (float)number);
                lua_pushnumber(L, number);
                break;
        }
    }
    lua_call(L, args-2, 1);

    // BRAIN DAMAGE -- need to convert the return value
    type = [signature methodReturnType];
    switch (type[strlen(type)-1])
    {
        id idBuffer;
        const char *charPtr;

        case _C_ID:
            idBuffer = luaTypeToid(L);
            NSLog(@"converting return type: %@", idBuffer);
            [anInvocation setReturnValue:&idBuffer];
            break;
        case _C_CHARPTR:
            // we go through two channels to get an autoreleased const char *
            // to control when it disappears
            charPtr = [[NSString stringWithCString:lua_tostring(L, -1)] cString];
            [anInvocation setReturnValue:&charPtr];
            break;
        case _C_UCHR:
            charBuffer = (char)(unsigned char)lua_tonumber(L, -1);
            [anInvocation setReturnValue:&charBuffer];
            break;
        case _C_CHR:
            charBuffer = (char)lua_tonumber(L, -1);
            [anInvocation setReturnValue:&charBuffer];
            break;
        case _C_USHT:
            shortBuffer = (short)(unsigned short)lua_tonumber(L, -1);
            [anInvocation setReturnValue:&shortBuffer];
            break;
        case _C_SHT:
            shortBuffer = (short)lua_tonumber(L, -1);
            [anInvocation setReturnValue:&shortBuffer];
            break;
        case _C_UINT:
            intBuffer = (int)(unsigned int)lua_tonumber(L, -1);
            [anInvocation setReturnValue:&intBuffer];
            break;
        case _C_INT:
            intBuffer = (int)lua_tonumber(L, -1);
            [anInvocation setReturnValue:&intBuffer];
            break;
        case _C_ULNG:
            longBuffer = (long)(unsigned long)lua_tonumber(L, -1);
            [anInvocation setReturnValue:&longBuffer];
            break;
        case _C_LNG:
            longBuffer = (long)lua_tonumber(L, -1);
            [anInvocation setReturnValue:&longBuffer];
            break;
        case _C_FLT:
            floatBuffer = (float)lua_tonumber(L, -1);
            [anInvocation setReturnValue:&floatBuffer];
            break;
        case _C_DBL:
            doubleBuffer = (double)lua_tonumber(L, -1);
            [anInvocation setReturnValue:&doubleBuffer];
            break;

        default:
            break;
    }
}


@implementation LuaProxy

-(id)initWithSuperclassInstance:(id)aSuper instanceMethods:(LuaReference*)aLuaRefInstance
{
    superInstance = [aSuper retain];
    NSLog(@"initWithSuperclassInstance: %@", aSuper);
    instanceMethods = [aLuaRefInstance retain];
    return self;
}

-(void)dealloc
{
    [superInstance release];
    [instanceMethods release];
}

-(void)forwardInvocation:(NSInvocation *)anInvocation
{
    const char *selectorName = sel_getName([anInvocation selector]);
    unsigned selectorLen = strlen(selectorName);
    char *luaSelector = alloca(selectorLen+1);
    LuaState *state = [instanceMethods luaState];
    lua_State *L = [state lua_State];
    int i;
    strcpy(luaSelector, selectorName);
    for (i=0;i<selectorLen;i++) if (luaSelector[i] == ':') luaSelector[i] = '_';

    // is method available in Lua? If so, call Lua.
    NSLog(@"in -forwardInvocation: %p", L);

    [instanceMethods copyLuaObjectToTopOfStack];
    if (!lua_istable(L,-1))
    {
        [anInvocation invokeWithTarget:superInstance];
        return;
    }
    lua_pushstring(L, luaSelector);
    lua_gettable(L, -2);
    if (lua_isfunction(L,-1))
    {
        invokeLuaFunctionOnTopOfStack(state, anInvocation);
        return;
    }
    [anInvocation invokeWithTarget:superInstance];
}

-(NSMethodSignature *)methodSignatureForSelector:(SEL)aSelector
{
    const char *selectorName;
    unsigned selectorLen;
    char *luaSelector;
    lua_State *L;
    int i;

    NSMethodSignature *ms = [superInstance methodSignatureForSelector:aSelector];
    if (ms != nil) return ms;

    // check to see if Lua implements the method

    selectorName = sel_getName(aSelector);
    selectorLen = strlen(selectorName);
    luaSelector = alloca(selectorLen+1);
    L = [[instanceMethods luaState] lua_State];

    strcpy(luaSelector, selectorName);
    for (i=0;i<selectorLen;i++) if (luaSelector[i] == ':') luaSelector[i] = '_';

    // is method available in Lua? If so, call Lua.
    [instanceMethods copyLuaObjectToTopOfStack];
    if (!lua_istable(L,-1))
    {
        return nil;
    }
    lua_pushstring(L, luaSelector);
    lua_gettable(L, -2);
    if (lua_isfunction(L,-1))
    {
        NSLog(@"Got a function in methodSignatureForSelector!");
        return luaMethodSignatureForSelectorName(luaSelector);
        // return LuaMethodSignature(function); // clever subclass of NSMethodSignature that only deals in ids
    }
    return nil;
}

@end
