// ** See Copyright Notice at the end of this file

#import "LuaState.h"
#include "lua.h"
#import "gluelib.h"

@implementation LuaState

-(void)doGlueLib
{
}

+(id)luaState
{
    return [self luaStateWithStackSize:0];
}

+(id)luaStateWithStackSize:(unsigned)aStackSize
{
    lua_State *newState = lua_open(aStackSize);
    return [self luaStateWithLua_State:newState];
}

+(id)luaStateWithLua_State:(lua_State*)aState
{
    return [[[LuaState alloc] initLuaStateWithLua_State:aState] autorelease];
}

-(id)initLuaStateWithLua_State:(lua_State*)aState
{
    [super init];
    L = aState;
    idTag = lua_newtag(aState);
    classTag = lua_newtag(aState);
    selectorOnObjectTag = lua_newtag(aState);
    lua_baselibopen(L);
    opengluelib(L, self);
    return self;
}

-(void)dealloc
{
    lua_close(L);
    [super dealloc];
}

-(lua_State*)lua_State
{
    return L;
}

@end

/*
 * Copyright (c) 2001 By Richard Kiss
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
 * TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
 
