
print("Hello!")

local ConverterControllerTemplate = {

    -- variables: converter, dollarField, rateField, totalField

	setConverter_ = function(s, v) s.converter = v end,
	setDollarField_ = function(s, v) s.dollarField = v end,
	setRateField_ = function(s, v) s.rateField = v end,
	setTotalField_ = function(s, v) s.totalField = v end,

    -- methods: -(void)convert:(id)sender and -(void)awakeFromNib

    convert_ =
        function(s, sender)
            s.amount = s.dollarField.floatValue()
            s.rate = s.rateField.floatValue()
            local total = s.converter.convertAmount_byRate_(s.amount, s.rate)
            s.totalField.setFloatValue_(total.doubleValue())
            s.rateField.selectText_(s)
        end,

    awakeFromNib =
        function(s)
            print("IN awakeFromNib!!!!")
            s.rateField.selectText_(s)
            s.rateField.window().makeKeyAndOrderFront_(s)
        end
}

subclass("ConverterController", NSObject, ConverterControllerTemplate)


ConverterClassTemplate = {
    -- this function replaces "- (float)convertAmount:(float)amount byRate:(float)rate"

    convertAmount_byRate_ =
        function(s, amount, rate)
            local a = amount.floatValue()
            local r = rate.floatValue()
            return NSNumber.numberWithDouble_(a * r)
        end,

    -- a function called after init
    didInit = function(s) print("in didInit") end
}

subclass("Converter", NSObject, ConverterClassTemplate)
