/* 
  You may freely copy, distribute, and reuse the code in this example.
  Apple disclaims any warranty of any kind, expressed or implied, as to its
  fitness for any particular use.
*/

#import "Converter.h"

@implementation Converter

-(id)init
{
    NSString *path = [[[NSHomeDirectory() stringByAppendingPathComponent:@"Library"]
        stringByAppendingPathComponent:@"CurrencyConverter2"]
            stringByAppendingPathComponent:@"converted.lua"];

    [super init];
    state = [[LuaState luaState] retain];
    // create a default implementation of the callback that doesn't do anything
    lua_dostring([state lua_State], "function converted() end");
    if ([[NSFileManager defaultManager] fileExistsAtPath:path])
    {
        lua_dofile([state lua_State], [path cString]);
    }
    return self;
}

-(void)dealloc
{
    [state dealloc];
}

- (float)convertAmount:(float)amount byRate:(float)rate
{
    // pass in the amount and the rate into the "converted" function
    char s[500];
    snprintf(s, 500, "converted(%f,%f)", amount, rate);
    lua_dostring([state lua_State], s);
    // if the function isn't defined, Lua will print an error message and fail
    return (amount * rate);
}

@end
