/* 
  You may freely copy, distribute, and reuse the code in this example.
  Apple disclaims any warranty of any kind, expressed or implied, as to its
  fitness for any particular use.
*/

#import "Converter.h"

@implementation Converter

-(id)init
{
    NSString *path = [[[NSHomeDirectory() stringByAppendingPathComponent:@"Library"]
        stringByAppendingPathComponent:@"CurrencyConverter3"]
            stringByAppendingPathComponent:@"converted.lua"];
    [super init];
    state = [[LuaState luaState] retain];

    if ([[NSFileManager defaultManager] fileExistsAtPath:path])
    {
        lua_dofile ([state lua_State], [path cString]);
    }
    return self;
}

-(void)dealloc
{
    [state dealloc];
}

- (float)convertAmount:(float)amount byRate:(float)rate
{
    [[NSNotificationCenter defaultCenter]
        postNotificationName:@"ConvertingAmountNotification"
                      object:self
                    userInfo:[NSDictionary dictionaryWithObjectsAndKeys:
                        [NSNumber numberWithFloat:amount], @"amount",
                        [NSNumber numberWithFloat:rate], @"rate", nil]];

    return (amount * rate);
}

@end
